import { ConnectionOptions, Connection } from "mysql2/promise";
export interface ConnectorOptions {
    logs?: boolean;
    sync?: boolean;
}
export declare class Connector {
    protected ConnectionOptions: ConnectionOptions & {
        multipleStatements?: true;
        database: string;
    };
    protected ConnectorOptions: ConnectorOptions;
    protected Ready: boolean;
    protected Connection: Connection;
    constructor(ConnectionOptions: ConnectionOptions & {
        multipleStatements?: true;
        database: string;
    }, ConnectorOptions?: ConnectorOptions);
    connect: () => Promise<this>;
    reConnect: () => Promise<this>;
    end: () => this;
    getConnection: () => Connection;
    getConnectionOptions: () => ConnectionOptions & {
        multipleStatements?: true | undefined;
        database: string;
    };
    getConnectorOptions: () => ConnectorOptions;
}
