import { SQLBoolean } from "./data-types/boolean";
import { SQLContent } from "./data-types/content";
import { SQLEnum } from "./data-types/enum";
import { SQLManyRelation } from "./data-types/many-relation";
import { SQLMeta } from "./data-types/meta";
import { SQLNumber } from "./data-types/number";
import { SQLObject } from "./data-types/object";
import { SQLOneRelation } from "./data-types/one-relation";
import { PrimaryKey } from "./data-types/primaryKey";
import { SQLString } from "./data-types/string";
import { LockedSchema, SQL_HEADERS } from "./locked-schema";
import { Schema, SQL_SCHEMA } from "./schema";
export declare type LockedSchemaType<T extends LockedSchema<any>> = T extends LockedSchema<infer R> ? R : never;
export declare type SchemaType<T extends Schema<any>> = T extends Schema<infer R> ? R : never;
export declare type SchemaDataType<T extends SQL_SCHEMA> = {
    -readonly [key in keyof T]?: SQLDataType<T[key]> extends SQLOneRelation<any> ? never : SQLDataType<T[key]> extends SQLManyRelation<any> ? never : SQLDataType<T[key]> extends SQLMeta<any> ? never : SQLDataType<T[key]>;
};
export declare type SchemaReturnDataType<T extends SQL_SCHEMA> = {
    _id: number;
    _headers?: SQL_HEADERS;
} & {
    -readonly [key in keyof T]: SQLDataType<T[key]> extends SQLOneRelation<infer R> ? SchemaReturnDataType<SchemaType<LockedSchemaType<R>>> : SQLDataType<T[key]> extends SQLManyRelation<infer R> ? Array<SchemaReturnDataType<SchemaType<LockedSchemaType<R>>>> : SQLDataType<T[key]> extends SQLMeta<infer R> ? R : SQLDataType<T[key]> extends Schema<infer R> ? SchemaReturnDataType<R> : SQLDataType<T[key]>;
};
export declare type SchemaRequiredDataType<T extends SQL_SCHEMA> = {
    -readonly [key in keyof T]?: SQLDataType<T[key]> extends SQLOneRelation<infer R> ? SchemaRequiredDataType<SchemaType<LockedSchemaType<R>>> : SQLDataType<T[key]> extends SQLManyRelation<infer R> ? Array<SchemaRequiredDataType<SchemaType<LockedSchemaType<R>>>> : SQLDataType<T[key]> extends SQLMeta<any> ? never : SQLDataType<T[key]>;
};
export declare type SCHEMA<T extends Schema<any>> = SchemaReturnDataType<SchemaType<T>>;
export declare type SQLDataType<T extends PrimaryKey | SQLString<any, any, any> | SQLContent<any, any, any> | SQLEnum<any, any, any> | SQLNumber<any, any, any> | SQLBoolean<any, any, any> | SQLObject<any, any, any> | SQLMeta<any> | SQLOneRelation<any> | SQLManyRelation<any>> = T extends PrimaryKey ? number : T extends SQLObject<infer R, any, any> ? R : T extends SQLNumber<any, any, any> ? number : T extends SQLString<any, any, any> | SQLContent<any, any, any> | SQLEnum<any, any, any> ? T extends SQLEnum<infer R, any, any> ? R : string : T extends SQLBoolean<any, any, any> ? boolean : T extends SQLMeta<infer R> ? R : T;
