import { SQLFunction } from "../utils";
export declare type Value<T> = T | SQLFunction | (() => Promise<T> | T);
export declare type ValidationFunction<T> = (value: any) => Promise<Value<T>> | Value<T>;
export declare type ResolverFunction<T> = (value: any) => Promise<Value<T>> | Value<T>;
export declare type SQLBaseTypeOptions<T, Public extends boolean, Nullable extends boolean> = {
    isPublic?: Public;
    isNullable?: Nullable;
    isUnique?: boolean;
    isLength?: number;
    isBinary?: boolean;
    isSearchable?: boolean;
    collation?: string;
    defaultValue?: Nullable extends true ? Value<T> | null : Value<T>;
    updatedValue?: Value<T>;
};
export declare class SQLBaseType<T extends string | number | boolean | object, Public extends boolean, Nullable extends boolean> {
    isType: "VARCHAR" | "LONGTEXT";
    columnId: string;
    isVirtual: boolean;
    isPublic: boolean;
    isNullable: boolean;
    isUnique: boolean;
    isLength: number;
    isBinary: boolean;
    isSearchable: boolean;
    collation?: string;
    defaultValue: Value<T> | null;
    updatedValue?: Value<T>;
    validator: ValidationFunction<T>;
    resolver: ResolverFunction<T>;
    constructor(isType: "VARCHAR" | "LONGTEXT", options: SQLBaseTypeOptions<T, Public, Nullable>);
    toString: () => string;
}
