"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SQLBaseType = void 0;
class SQLBaseType {
    constructor(isType, options) {
        this.isType = isType;
        // If True then will not be considered as Mysql table column.
        this.isVirtual = false;
        // Whether the columns should be retrived with each request?
        this.isPublic = true;
        // If the column is nullable or not.
        this.isNullable = false;
        // If the column is unique or not.
        this.isUnique = false;
        // Length of content in the column.
        this.isLength = 50;
        // If the column is binary
        this.isBinary = false;
        // If the column is searchable
        this.isSearchable = false;
        // Default value of the column.
        this.defaultValue = null;
        // Validation Function
        this.validator = () => undefined;
        // Validation Function
        this.resolver = () => undefined;
        this.toString = () => [
            this.isType === "LONGTEXT" ? "LONGTEXT" : `VARCHAR(${this.isLength})`,
            this.isBinary ? `BINARY` : undefined,
            this.isNullable ? `NULL` : `NOT NULL`,
            this.isUnique && this.isType === "VARCHAR" ? `UNIQUE` : undefined,
            this.collation ? `COLLATE ${this.collation}` : undefined,
        ]
            .filter((v) => v)
            .join(" ");
        if (typeof options.isPublic === "boolean")
            this.isPublic = options.isPublic;
        if (typeof options.isNullable === "boolean")
            this.isNullable = options.isNullable;
        if (typeof options.isUnique === "boolean")
            this.isUnique = options.isUnique;
        if (typeof options.isLength === "number" && options.isLength > 0)
            this.isLength = options.isLength;
        if (typeof options.isBinary === "boolean")
            this.isBinary = options.isBinary;
        if (typeof options.isSearchable === "boolean")
            this.isSearchable = options.isSearchable;
        if (typeof options.collation === "string")
            this.collation = options.collation;
        if (typeof options.defaultValue !== "undefined")
            this.defaultValue = options.defaultValue;
        if (typeof options.updatedValue !== "undefined")
            this.updatedValue = options.updatedValue;
    }
}
exports.SQLBaseType = SQLBaseType;
