import { SQLBaseType, SQLBaseTypeOptions, ResolverFunction, ValidationFunction } from "./base";
export declare type SQLBooleanType<T extends SQLBoolean<any, any, any>> = T extends SQLBoolean<infer V, infer X, infer Y> ? X extends false ? V | undefined : Y extends true ? V | undefined | null : V : any;
export interface SQLBooleanOptions<T extends boolean, Public extends boolean, Nullable extends boolean> extends SQLBaseTypeOptions<T, Public, Nullable> {
    validator?: ValidationFunction<T>;
    resolver?: ResolverFunction<T>;
}
export declare class SQLBoolean<T extends boolean, Public extends boolean, Nullable extends boolean> extends SQLBaseType<T, Public, Nullable> {
    readonly _id = "Boolean";
    validator: ValidationFunction<T>;
    resolver: ResolverFunction<T>;
    constructor(options?: SQLBooleanOptions<T, Public, Nullable>);
}
