import { ResolverFunction, SQLBaseType, SQLBaseTypeOptions, ValidationFunction } from "./base";
export declare type SQLEnumType<T extends SQLEnum<any, any, any>> = T extends SQLEnum<infer V, infer X, infer Y> ? X extends false ? V | undefined : Y extends true ? V | undefined | null : V : any;
export interface SQLEnumOptions<T extends string, Public extends boolean, Nullable extends boolean> extends SQLBaseTypeOptions<T, Public, Nullable> {
    validator?: ValidationFunction<T>;
    resolver?: ResolverFunction<T>;
}
export declare class SQLEnum<T extends string, Public extends boolean, Nullable extends boolean> extends SQLBaseType<T, Public, Nullable> {
    readonly choices: T[];
    readonly _id = "Enum";
    validator: ValidationFunction<T>;
    resolver: ResolverFunction<T>;
    constructor(choices: T[], options?: SQLEnumOptions<T, Public, Nullable>);
}
