"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SQLManyRelation = void 0;
const exceptions_1 = require("../exceptions");
class SQLManyRelation {
    constructor(Schema, Column, resolver) {
        this.Schema = Schema;
        this.Column = Column;
        this.resolver = resolver;
        // Data type ID. Used to defer from other datatypes.
        this._id = "ManyRelation";
        // If True then will not be considered as Mysql table column.
        this.isVirtual = true;
        // Default value of the column.
        this.defaultValue = null;
        // Validate input value.
        this.validator = () => { };
        this.setResolver = (resolver) => {
            this.resolver = resolver;
            return this;
        };
        this.setForeignColumn = (column) => {
            if ((this.Column instanceof Array && column instanceof Array) ||
                (typeof this.Column === "string" && typeof column === "string")) {
                if (this.Column instanceof Array && column.length === this.Column.length)
                    this.ForeignColumn = column;
                else if (typeof this.Column === "string")
                    this.ForeignColumn = column;
                else
                    throw new exceptions_1.SQLException(`Please map the Foreign Columns according to Relation Columns! Invalid Foreign Columns length!`);
            }
            else
                throw new exceptions_1.SQLException(this.Column instanceof Array
                    ? `Foreign Columns should be a list of Columns as Array!`
                    : `Foreign Column should be a string!`);
            return this;
        };
    }
}
exports.SQLManyRelation = SQLManyRelation;
