import { ResolverFunction, SQLBaseType, SQLBaseTypeOptions, ValidationFunction } from "./base";
export declare type SQLNumberType<T extends SQLNumber<any, any, any>> = T extends SQLNumber<any, infer X, infer Y> ? X extends false ? number | undefined : Y extends true ? number | undefined | null : number : any;
export interface SQLNumberOptions<T extends number, Public extends boolean, Nullable extends boolean> extends SQLBaseTypeOptions<T, Public, Nullable> {
    decimalLength?: number;
    validator?: ValidationFunction<T>;
    resolver?: ResolverFunction<T>;
}
export declare class SQLNumber<T extends number, Public extends boolean, Nullable extends boolean> extends SQLBaseType<T, Public, Nullable> {
    readonly _id = "Number";
    isLength: number;
    decimalLength: number;
    validator: ValidationFunction<T>;
    resolver: ResolverFunction<T>;
    constructor(options?: SQLNumberOptions<T, Public, Nullable>);
}
