import { ResolverFunction, SQLBaseType, SQLBaseTypeOptions, ValidationFunction, Value } from "./base";
export declare type SQLObjectType<T extends SQLObject<any, any, any>> = T extends SQLObject<infer V, infer X, infer Y> ? X extends false ? V | undefined : Y extends true ? V | undefined | null : V : any;
export interface SQLObjectOptions<T extends Record<any, any>, Public extends boolean, Nullable extends boolean> extends SQLBaseTypeOptions<T, Public, Nullable> {
    validator?: ValidationFunction<T>;
    resolver?: ResolverFunction<T>;
}
export declare class SQLObject<T extends Record<any, any>, Public extends boolean, Nullable extends boolean> extends SQLBaseType<T, Public, Nullable> {
    readonly _id = "Object";
    defaultValue: Value<T>;
    validator: ValidationFunction<T>;
    resolver: ResolverFunction<T>;
    constructor(options?: SQLObjectOptions<T, Public, Nullable>);
}
