import { ValidationFunction, Value } from "./base";
import { LockedSchema } from "../locked-schema";
import { Schema } from "../schema";
import { LockedSchemaType, SchemaDataType, SchemaType } from "../data-types";
export declare type OneRelationColumnMapping<S extends LockedSchema<Schema<any>>> = {
    [key in keyof LockedSchemaType<S>]?: string;
};
export interface SQLOneRelationOptions {
}
export declare class SQLOneRelation<S extends LockedSchema<Schema<any>>> {
    Schema: (id: string) => S;
    Column: (keyof SchemaDataType<SchemaType<LockedSchemaType<S>>> & string) | Array<keyof SchemaDataType<SchemaType<LockedSchemaType<S>>> & string>;
    resolver?: ((record: SchemaDataType<SchemaType<LockedSchemaType<S>>> & Record<any, any>, schema: S, resources: any) => SchemaDataType<SchemaType<LockedSchemaType<S>>> & Record<any, any>) | undefined;
    readonly _id = "OneRelation";
    columnId: string;
    isVirtual: boolean;
    defaultValue: Value<any>;
    updateValue?: Value<any>;
    ForeignColumn?: string | string[];
    validator: ValidationFunction<any>;
    constructor(Schema: (id: string) => S, Column: (keyof SchemaDataType<SchemaType<LockedSchemaType<S>>> & string) | Array<keyof SchemaDataType<SchemaType<LockedSchemaType<S>>> & string>, resolver?: ((record: SchemaDataType<SchemaType<LockedSchemaType<S>>> & Record<any, any>, schema: S, resources: any) => SchemaDataType<SchemaType<LockedSchemaType<S>>> & Record<any, any>) | undefined);
    setResolver: (resolver: (record: SchemaDataType<SchemaType<LockedSchemaType<S>>> & Record<any, any>, schema: S) => SchemaDataType<SchemaType<LockedSchemaType<S>>> & Record<any, any>) => this;
    setForeignColumn: (column: string | string[]) => this;
}
