import { ResolverFunction, SQLBaseType, SQLBaseTypeOptions, ValidationFunction } from "./base";
export declare type SQLStringType<T extends SQLString<any, any, any>> = T extends SQLString<any, infer X, infer Y> ? X extends false ? string | undefined : Y extends true ? string | undefined | null : string : any;
export interface SQLStringOptions<T extends string, Public extends boolean, Nullable extends boolean> extends SQLBaseTypeOptions<T, Public, Nullable> {
    validator?: ValidationFunction<T>;
    resolver?: ResolverFunction<T>;
}
export declare class SQLString<T extends string, Public extends boolean, Nullable extends boolean> extends SQLBaseType<T, Public, Nullable> {
    readonly _id = "String";
    validator: ValidationFunction<T>;
    resolver: ResolverFunction<T>;
    constructor(options?: SQLStringOptions<T, Public, Nullable>);
}
