import { ConditionWhere, SelectionColumns } from "./conditions-builder";
import { LockedSchema } from "./locked-schema";
import { Schema } from "./schema";
export declare class SQLMatch<S extends Schema<any>> {
    columns: Array<SelectionColumns<LockedSchema<S>> | "_id">;
    search?: string | undefined;
    protected modes: {
        naturalLanguage: string;
        boolean: string;
    };
    protected relevances: {
        queryExpansion: string;
    };
    WHERE?: ConditionWhere<LockedSchema<S>>;
    operation: string;
    modifier: string;
    relevance: string;
    constructor(columns: Array<SelectionColumns<LockedSchema<S>> | "_id">, search?: string | undefined);
    where: (conditions: ConditionWhere<LockedSchema<S>>, operation?: "OR" | "AND" | undefined) => this;
    mode: (mode?: "boolean" | "naturalLanguage" | undefined) => this;
    with: (relevance?: "queryExpansion" | undefined) => this;
}
export declare class SQLFunction {
    protected functionString: string;
    constructor(functionString: string);
    toString: () => string;
}
export declare class SQLNotSelection<T> {
    protected selection: T[];
    constructor(selection: T[]);
    get: () => T[];
}
export declare class SQLSelection<T> {
    protected selection: T[];
    constructor(selection: T[]);
    get: () => T[];
}
export declare class SQL_UUID {
    static SHORT: () => number;
    SHORT: () => number;
}
