"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SQL_UUID = exports.SQLSelection = exports.SQLNotSelection = exports.SQLFunction = exports.SQLMatch = void 0;
class SQLMatch {
    constructor(columns, search) {
        this.columns = columns;
        this.search = search;
        this.modes = {
            naturalLanguage: "NATURAL LANGUAGE",
            boolean: "BOOLEAN",
        };
        this.relevances = {
            queryExpansion: "QUERY EXPANSION",
        };
        this.operation = "";
        this.modifier = "";
        this.relevance = "";
        this.where = (conditions, operation) => {
            this.WHERE = conditions;
            this.operation = operation || "AND";
            return this;
        };
        this.mode = (mode) => {
            if (mode)
                this.modifier = `IN ${this.modes[mode]} MODE`;
            return this;
        };
        this.with = (relevance) => {
            if (relevance)
                this.relevance = `WITH ${this.relevances[relevance]}`;
            return this;
        };
    }
}
exports.SQLMatch = SQLMatch;
class SQLFunction {
    constructor(functionString) {
        this.toString = () => this.functionString;
        this.functionString = functionString;
    }
}
exports.SQLFunction = SQLFunction;
class SQLNotSelection {
    constructor(selection) {
        this.selection = selection;
        this.get = () => this.selection;
    }
}
exports.SQLNotSelection = SQLNotSelection;
class SQLSelection {
    constructor(selection) {
        this.selection = selection;
        this.get = () => this.selection;
    }
}
exports.SQLSelection = SQLSelection;
class SQL_UUID {
    constructor() {
        this.SHORT = SQL_UUID.SHORT;
    }
}
exports.SQL_UUID = SQL_UUID;
SQL_UUID.SHORT = () => parseInt((parseInt(parseInt((new Date().getTime() / 3.3).toString()).toString() +
    parseInt((Math.random() * 10000).toString())) + new Date().getMilliseconds())
    .toString()
    .replace(".", ""));
